import com.cycling74.max.*;


// only one 'gesture' and none of the nifty randomness in this one
class BGblues1 extends MaxObject {
	riff theRiff;

	public BGblues1() {
		double q = 1.0;
		double e = 0.5;
		double dq = 0.75;

		double [] parr1 = { 0.00, 0.07, 0.00, 0.07, 0.00, 0.09, 0.00, 0.09 };
		double [] darr1 = { dq,   0.0,  e,    0.0,  dq,   0.0,  e,    0.0  };
		String [] iarr1 = { "n",  "n",  "n",  "n",  "n",  "n",  "n",  "n", };
		theRiff = new riff(parr1.length, parr1, darr1, iarr1);
	}
		
	public void godaddy(float basenote, float beat) {
		float st, pch, d;
		int i;

		st = (float)0.0;
		d = (float)0.0;
		for (i = 0; i < theRiff.numnotes; i++) {
			// get pitch
			pch = basenote + (float)theRiff.pitches[i];
			
			// get dur -- if the dur is 0, the note is stacked
			if (theRiff.durs[i] != 0) d = beat * (float)theRiff.durs[i];
			else st = st - d; // set st back to stack the note

			// write out the note!
			if (theRiff.inflects[i] == "n")
				outlet(0, "rtcmix START1 " + st + " " + d + " " + pch + " 1.0 1.0 100.0 0.1 6.00 0.0 1.0 20000.0 9.0");

			st = st + d;
		}
	}


	class riff {
	// this class holds the data in 3 arrays:  pitches[], durs[], inflects[]
	//		pitches[] are pitch-offsets (oct.pc) of a base note
	//		durs[] are duration multipliers of a base beat
	// 	inflects[] are strings "n", "b", "v" (normal/bend/vibrato)
	//	also it holds how many notes in each riff
		float [] pitches;
		float [] durs;
		String [] inflects;
		int numnotes;

		public riff(int nnotes, double [] pchs, double [] ds, String [] infs) {
			int i;

			numnotes = nnotes;
			pitches = new float[nnotes];
			durs = new float[nnotes];
			inflects = new String[nnotes];
			// load 'em up
			for (i = 0; i < nnotes; i++) {
				pitches[i] = (float)pchs[i];
				durs[i] = (float)ds[i];
				inflects[i] = infs[i];
			}
		}
	}
}

